From 993918b0cf69d755aef6504465e75c0eb768df98 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 16 2020 06:54:39 +0000
Subject: [PATCH 133/2232] Merge pull request #69 from dtolnay/void


Add Type::Void variant
---

diff --git a/gen/write.rs b/gen/write.rs
index f74fb74..3cd3683 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -472,6 +472,7 @@ fn write_type(out: &mut OutFile, ty: &Type) {
         Type::Str(_) => {
             write!(out, "::rust::Str");
         }
+        Type::Void(_) => unreachable!(),
     }
 }
 
@@ -480,6 +481,7 @@ fn write_type_space(out: &mut OutFile, ty: &Type) {
     match ty {
         Type::Ident(_) | Type::RustBox(_) | Type::UniquePtr(_) | Type::Str(_) => write!(out, " "),
         Type::Ref(_) => {}
+        Type::Void(_) => unreachable!(),
     }
 }
 
diff --git a/syntax/check.rs b/syntax/check.rs
index df633de..ef3faff 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -1,5 +1,5 @@
 use crate::syntax::atom::Atom::{self, *};
-use crate::syntax::{error, ident, Api, ExternFn, Ty1, Type, Types, Var};
+use crate::syntax::{error, ident, Api, ExternFn, Ref, Ty1, Type, Types, Var};
 use proc_macro2::Ident;
 use syn::{Error, Result};
 
@@ -40,6 +40,11 @@ pub(crate) fn typecheck(apis: &[Api], types: &Types) -> Result<()> {
                 }
                 errors.push(unsupported_unique_ptr_target(ptr));
             }
+            Type::Ref(ty) => {
+                if let Type::Void(_) = ty.inner {
+                    errors.push(unsupported_reference_type(ty));
+                }
+            }
             _ => {}
         }
     }
@@ -94,6 +99,7 @@ pub(crate) fn typecheck(apis: &[Api], types: &Types) -> Result<()> {
 fn is_unsized(ty: &Type, types: &Types) -> bool {
     let ident = match ty {
         Type::Ident(ident) => ident,
+        Type::Void(_) => return true,
         _ => return false,
     };
     ident == CxxString || types.cxx.contains(ident) || types.rust.contains(ident)
@@ -161,6 +167,7 @@ fn describe(ty: &Type, types: &Types) -> String {
         Type::UniquePtr(_) => "unique_ptr".to_owned(),
         Type::Ref(_) => "reference".to_owned(),
         Type::Str(_) => "&str".to_owned(),
+        Type::Void(_) => "()".to_owned(),
     }
 }
 
@@ -168,6 +175,10 @@ fn unsupported_type(ident: &Ident) -> Error {
     Error::new(ident.span(), "unsupported type")
 }
 
+fn unsupported_reference_type(ty: &Ref) -> Error {
+    Error::new_spanned(ty, "unsupported reference type")
+}
+
 fn unsupported_cxx_type_in_box(unique_ptr: &Ty1) -> Error {
     Error::new_spanned(unique_ptr, error::BOX_CXX_TYPE.msg)
 }
diff --git a/syntax/impls.rs b/syntax/impls.rs
index 8153f03..741431a 100644
--- a/syntax/impls.rs
+++ b/syntax/impls.rs
@@ -1,5 +1,36 @@
-use crate::syntax::{Ref, Ty1};
+use crate::syntax::{Ref, Ty1, Type};
 use std::hash::{Hash, Hasher};
+use std::mem;
+
+impl Hash for Type {
+    fn hash<H: Hasher>(&self, state: &mut H) {
+        mem::discriminant(self).hash(state);
+        match self {
+            Type::Ident(t) => t.hash(state),
+            Type::RustBox(t) => t.hash(state),
+            Type::UniquePtr(t) => t.hash(state),
+            Type::Ref(t) => t.hash(state),
+            Type::Str(t) => t.hash(state),
+            Type::Void(_) => {}
+        }
+    }
+}
+
+impl Eq for Type {}
+
+impl PartialEq for Type {
+    fn eq(&self, other: &Type) -> bool {
+        match (self, other) {
+            (Type::Ident(lhs), Type::Ident(rhs)) => lhs == rhs,
+            (Type::RustBox(lhs), Type::RustBox(rhs)) => lhs == rhs,
+            (Type::UniquePtr(lhs), Type::UniquePtr(rhs)) => lhs == rhs,
+            (Type::Ref(lhs), Type::Ref(rhs)) => lhs == rhs,
+            (Type::Str(lhs), Type::Str(rhs)) => lhs == rhs,
+            (Type::Void(_), Type::Void(_)) => true,
+            (_, _) => false,
+        }
+    }
+}
 
 impl Eq for Ty1 {}
 
diff --git a/syntax/mod.rs b/syntax/mod.rs
index c5cc1de..8c7e5ca 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -12,7 +12,7 @@ pub mod set;
 mod tokens;
 pub mod types;
 
-use proc_macro2::Ident;
+use proc_macro2::{Ident, Span};
 use syn::{LitStr, Token};
 
 pub use self::atom::Atom;
@@ -63,13 +63,13 @@ pub struct Receiver {
     pub ident: Ident,
 }
 
-#[derive(Hash, Eq, PartialEq)]
 pub enum Type {
     Ident(Ident),
     RustBox(Box<Ty1>),
     UniquePtr(Box<Ty1>),
     Ref(Box<Ref>),
     Str(Box<Ref>),
+    Void(Span),
 }
 
 pub struct Ty1 {
diff --git a/syntax/parse.rs b/syntax/parse.rs
index efe6ff8..67bb52b 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -180,7 +180,10 @@ fn parse_extern_fn(foreign_fn: &ForeignItemFn) -> Result<ExternFn> {
     }
     let ret = match &foreign_fn.sig.output {
         ReturnType::Default => None,
-        ReturnType::Type(_, ty) => Some(parse_type(ty)?),
+        ReturnType::Type(_, ty) => match parse_type(ty)? {
+            Type::Void(_) => None,
+            ty => Some(ty),
+        },
     };
     let doc = attrs::parse_doc(&foreign_fn.attrs)?;
     let fn_token = foreign_fn.sig.fn_token;
@@ -251,6 +254,9 @@ fn parse_type(ty: &RustType) -> Result<Type> {
                 }
             }
         }
+        RustType::Tuple(ty) if ty.elems.is_empty() => {
+            return Ok(Type::Void(ty.paren_token.span));
+        }
         _ => {}
     }
     Err(Error::new_spanned(ty, "unsupported type"))
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index e97509b..52c47d5 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -16,6 +16,7 @@ impl ToTokens for Type {
             }
             Type::RustBox(ty) | Type::UniquePtr(ty) => ty.to_tokens(tokens),
             Type::Ref(r) | Type::Str(r) => r.to_tokens(tokens),
+            Type::Void(span) => tokens.extend(quote_spanned!(*span=> ())),
         }
     }
 }
diff --git a/syntax/types.rs b/syntax/types.rs
index 50f13b1..f9f87f3 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -23,7 +23,7 @@ impl<'a> Types<'a> {
         fn visit<'a>(all: &mut Set<'a, Type>, ty: &'a Type) {
             all.insert(ty);
             match ty {
-                Type::Ident(_) | Type::Str(_) => {}
+                Type::Ident(_) | Type::Str(_) | Type::Void(_) => {}
                 Type::RustBox(ty) | Type::UniquePtr(ty) => visit(all, &ty.inner),
                 Type::Ref(r) => visit(all, &r.inner),
             }

